/*@file             app.c
* @brief            Application implementation
* @author           hyh
* @date             2022.6.6
* @version          1.0
* @copyright        Chengdu Ebyte Electronic Technology Co.Ltd
**********************************************************************************
*/
#include "app.h"
//ȫֲ
Uart_Param_t Uart_Param = {0,0,0,0,{0}};
//Ƶȫֲ
RF_Param_t RF_Param = {0,0,{0}};
//ڷһֽ
#define Uart_SendByte()    EUSCI_A_UART_transmitData(EUSCI_A1_BASE,Uart_Param.Data2Uart[Uart_Param.SendPos++]);
//ڷæ־
INT8U UartTx_BusyFlag = 0;
//Auxæ־
INT8U AuxBusyFlag = 0;
/*!
================================================================================
------------------------------------Function-----------------------------------
================================================================================
*/
/*!
 *  @brief    Aux״̬ΪæAux
*/
void APP_Aux_Busy(void)
{
  if(AuxBusyFlag)  {return;}
  AuxBusyFlag = 1;
  hal_aux_busy();
}
/*!
 *  @brief   Aux״̬ΪУAux
*/
void APP_Aux_Free(void)
{
  if(!AuxBusyFlag)  {return;}
  AuxBusyFlag = 0;
  hal_aux_free();
}
/*!
 *  @brief    ڽжϴ
 *  @note
*/
void Uart_Rx_Interrupt_Cb(void)
{
    RF_Param.Data2RF[RF_Param.Need2Send++] = EUSCI_A_UART_receiveData(EUSCI_A1_BASE);
    Uart_Param.Timeout_Rx = 5;
    APP_Aux_Busy();
}
/*!
 *  @brief    ڷжϴ
 *  @note
*/
void Uart_Tx_Interrupt_Cb(void)
{
  if(Uart_Param.SendPos != Uart_Param.Need2Send)
  {
      UartTx_BusyFlag = 1;
      //ͻһֽ
      Uart_SendByte();
  }
  else
  {
      UartTx_BusyFlag = 0;
      APP_Aux_Free();
  }
  Uart_Param.Timeout_Tx = 10;
}
/*!
 *  @brief     1msʱжϴ
 *  @note
*/
void Systick_1ms_Interrupt_Cb(void)
{
  if(Uart_Param.Timeout_Rx != 0)
  {
    Uart_Param.Timeout_Rx--;
  }
  if(Uart_Param.Timeout_Tx != 0)
  {
    Uart_Param.Timeout_Tx--;
  }
}
/*!
 *  @brief     ڷbuffer
 *  @note
*/
void UART_Send(INT8U *buffer,INT16U len)
{
    if(len == 0)       {return;}
    while(len--)
    {
        Uart_Param.Data2Uart[Uart_Param.Need2Send++] = *buffer++;
    }
    Uart_Param.Timeout_Tx = 10;
    if(UartTx_BusyFlag)  {return;}
    UartTx_BusyFlag = 1;
    Uart_SendByte();
}
/*!
 *  @brief    鴮ڻǷݣ䷢
*/
void Uart_ErrorCheck(void)
{
  if((Uart_Param.SendPos != Uart_Param.Need2Send) &&(Uart_Param.Timeout_Tx == 0))
  {
    Uart_Param.Timeout_Tx = 10;
    if(UartTx_BusyFlag)  {return;}
    UartTx_BusyFlag = 1;
    Uart_SendByte();
  }
}
/*!
 *  @brief        鴮ڻǷݣְ
 *  @param        None
 *  @return       ְݳ
 *  @note
*/
INT8U Uart_RecieveLength(void)
{
  INT8U i,j = RF_PAYLOAD_MAX_SIZE;
  i = RF_Param.Need2Send - RF_Param.SendPos;
  if(i >= j)             { return j;}
  if(Uart_Param.Timeout_Rx == 0)  {return i;}
  return 0;
}
/*!
 *  @brief  ϵͳʼMCURFӲԴ
*/
void APP_System_Init(void)
{
    BSP_MCU_Init();
    BSP_RF_Init();
}
/*!
 *  @brief  ߷䴦
*/
void APP_TransmitHandler(void)
{
  INT8U i,length,buffer[RF_PAYLOAD_MAX_SIZE];
  if((length = Uart_RecieveLength()) != 0)
  {
    for(i=0;i<length;i++)
    {
      buffer[i] = RF_Param.Data2RF[RF_Param.SendPos++];
    }
    CC1101_SendPacket(buffer, length, ADDRESS_CHECK);
    Delay_ms(100);
    APP_Aux_Free();
    CC1101_SetTRMode(RX_MODE);
  }
}
/*!
 *  @brief  ߽մ
*/
void APP_ReceiveHandler(void)
{
    INT8U length,rcv_buffer[RF_PAYLOAD_MAX_SIZE];
    CC1101_SetTRMode(RX_MODE);
    if (0 == CC_IRQ_READ())
    {
      while (CC_IRQ_READ() == 0);
      APP_Aux_Busy();
      length = CC1101_RecievePacket(rcv_buffer);
      UART_Send(rcv_buffer,length);
    }
}
