/*@file             bsp.c
* @brief            the board support(MSP430FR2433)
* @author           hyh
* @date             2022.6.6
* @version          1.0
* @copyright        Chengdu Ebyte Electronic Technology Co.Ltd
**********************************************************************************
*/

#include "bsp.h"
/*!
================================================================================
------------------------------------Functions-----------------------------------
================================================================================
*/
/*!
 *  @brief        Initialize the MCU
 *  @note
*/
void BSP_MCU_Init(void)
{
    //ֹͣŹ
    WDT_A_hold(WDT_A_BASE);
    //GPIOʼ
    hal_gpio_init();
    //ʱӳʼ
    hal_clock_init();
    //ʱʼ
    hal_timer_init();
    //SPIʼ
    hal_spi_init();
    //ڳʼ
    hal_uart_init();
    //ȫж
    __enable_interrupt();
}
/*!
 *  @brief        Initialize the RF
 *  @note
*/
void BSP_RF_Init(void)
{
    //ƵоƬʼ
    CC1101_Init();
    //оƬģʽ
    CC1101_SetTRMode(RX_MODE);
    //Aux
    GPIO_setOutputHighOnPin(GPIO_PORT_AUX, GPIO_PIN_AUX);
}
