/*@file             hal_gpio.c
* @brief            the low level operation and configuration about GPIO
* @author           hyh
* @date             2022.6.6
* @version          1.0
* @copyright        Chengdu Ebyte Electronic Technology Co.Ltd
********************************************************************************
*/
#include "hal_gpio.h"
/*!
================================================================================
------------------------------------Functions-----------------------------------
================================================================================
*/
/*!
 *  @brief        Initialize the GPIO Configuration corresponding to the peripherals
 *  @note
*/
void hal_gpio_init(void)
{
    //The GPIO Configuration
    //AUX

    GPIO_setAsOutputPin(GPIO_PORT_AUX, GPIO_PIN_AUX);
    GPIO_setOutputLowOnPin(GPIO_PORT_AUX, GPIO_PIN_AUX);

    GPIO_setAsInputPinWithPullUpResistor(CC1101_CSN_PORT,CC1101_CSN_PIN);
    GPIO_setAsPeripheralModuleFunctionInputPin(UART_PORT,UART_TX_PIN,GPIO_PRIMARY_MODULE_FUNCTION);
    GPIO_setAsPeripheralModuleFunctionInputPin(UART_PORT,UART_RX_PIN,GPIO_PRIMARY_MODULE_FUNCTION);
    //SPI
    GPIO_setAsPeripheralModuleFunctionInputPin(SPI_PORT,SPI_PIN_MOSI|SPI_PIN_MISO|SPI_PIN_SCK,GPIO_PRIMARY_MODULE_FUNCTION);
    GPIO_setAsOutputPin(CC1101_CSN_PORT, CC1101_CSN_PIN);
    /*
     * Disable the GPIO power-on default high-impedance mode to activate
     * previously configured port settings
     */
    PMM_unlockLPM5();
}
void hal_aux_busy(void)
{
    GPIO_setOutputLowOnPin(GPIO_PORT_AUX, GPIO_PIN_AUX);
}
void hal_aux_free(void)
{
    GPIO_setOutputHighOnPin(GPIO_PORT_AUX, GPIO_PIN_AUX);
}
