/*@file             hal_timer.c
* @brief            the low level operation and configuration about Timer
* @author           hyh
* @date             2022.6.6
* @version          1.0
* @copyright        Chengdu Ebyte Electronic Technology Co.Ltd
**********************************************************************************
*/
#include "app.h"
#include "hal_timer.h"

INT16U ticks = 0;
/*!
================================================================================
------------------------------------Functions-----------------------------------
================================================================================
*/
/*!
 *  @brief        Initialize the Timer Configuration
 *  @note
*/
void hal_timer_init(void)
{
    TA0CCTL0 |= CCIE;
    TA0CCR0 = 8000;
    TA0CTL = TASSEL__SMCLK | MC__UP;
}
void Delay_ms(INT16U ms)
{
    ticks = 0;
    while(ticks < ms);
}
// Timer A0 interrupt service routine
#if defined(__TI_COMPILER_VERSION__) || defined(__IAR_SYSTEMS_ICC__)
#pragma vector = TIMER0_A0_VECTOR
__interrupt void Timer_A (void)
#elif defined(__GNUC__)
void __attribute__ ((interrupt(TIMER0_A0_VECTOR))) Timer_A (void)
#else
#error Compiler not supported!
#endif
{
    ticks++;
    Systick_1ms_Interrupt_Cb();
}
